/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: suspendchan
 * CMDLEVEL: QCMD_OPER
 * CMDARGS: 2
 * CMDDESC: Suspends a channel from the bot.
 * CMDFUNC: csc_dosuspendchan
 * CMDPROTO: int csc_dosuspendchan(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: suspendchan <channel> [<reason>]
 * CMDHELP: Suspends the specified channel, with an optional reason.
 */

#include "../chanserv.h"
#include "../../nick/nick.h"
#include "../../lib/flags.h"
#include "../../lib/irc_string.h"
#include "../../channel/channel.h"
#include "../../parser/parser.h"
#include "../../irc/irc.h"
#include "../../localuser/localuserchannel.h"
#include <string.h>
#include <stdio.h>

int csc_dosuspendchan(void *source, int cargc, char **cargv) {
  nick *sender=source;
  reguser *rup=getreguserfromnick(sender);
  chanindex *cip;
  regchan *rcp;

  if (!rup)
    return CMD_ERROR;

  if (cargc<2) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "suspendchan");
    return CMD_ERROR;
  }

  if(!checkreason(sender, cargv[1]))
    return CMD_ERROR;

  if (!(cip=findchanindex(cargv[0])) || !(rcp=cip->exts[chanservext])) {
    chanservstdmessage(sender, QM_UNKNOWNCHAN, cargv[0]);
    return CMD_ERROR;
  }

  if (CIsSuspended(rcp)) {
    chanservstdmessage(sender, QM_CHANNELALREADYSUSPENDED, cip->name->content);
    return CMD_ERROR;
  }

  CSetSuspended(rcp);
  rcp->suspendreason = getsstring(cargv[1], 250);
  rcp->suspendby = rup->ID;
  rcp->suspendtime = time(NULL);

  chanservwallmessage("%s (%s) used SUSPENDCHAN on %s (reason: %s)", sender->nick, rup->username, cip->name->content, rcp->suspendreason->content);

  cs_log(sender,"SUSPENDCHAN %s (%s)",cip->name->content,rcp->suspendreason->content);
  if(cip->channel) {
    char reasonbuf[512];
    
    snprintf(reasonbuf,511,"Channel suspended: %s",rcp->suspendreason->content);
    reasonbuf[511]=0;

    chanservpartchan(cip->channel, reasonbuf);
  }
  
  csdb_updatechannel(rcp);
  chanservstdmessage(sender, QM_DONE);

  return CMD_OK;
}
